// Pecon7 (9643)
// Tick events

registerOutputEvent(fxdtsbrick, setTickRate, "int 32 600000 100");
registerOutputEvent(fxdtsbrick, startTick, "", 1);
registerOutputEvent(fxdtsbrick, stopTick, "", 0);
registerOutputEvent(fxdtsbrick, pauseTick, "", 0);

registerInputEvent(fxdtsBrick, onTick, "Self fxDtsBrick");

function fxDtsBrick::brickLoopingEventLoop(%this, %client)
{
	$inputTarget_["Self"] = %this;
	%this.processInputEvent("onTick", %client);
	%this.lastLoopingEventTick = $sim::time;
	
	%this.loopingEventTick = %this.schedule(%this.loopingEventTickTime, brickLoopingEventLoop, %client);
}

function fxDtsBrick::setTickRate(%this, %rate)
{
	if(%rate < 32)
		return;
	
	%this.loopingEventTickTime = %rate;

	if(isEventPending(%this.loopingEventTick))
	{
		cancel(%this.loopingEventTick);
		
		%elapsed = mfloatLength(($sim::time - %this.lastLoopingEventTick)*1000, 0);
		
		if(%rate - %elapsed > 0)
			%firstSchedule = %rate - %elapsed;
			
		%this.loopingEventTick = %this.schedule(%firstSchedule, brickLoopingEventLoop, %this.loopingEventTickClient);
	}
	
}

function fxDtsBrick::startTick(%this, %client)
{
	if(%this.loopingEventTickTime < 32)
		return;

	if(isEventPending(%this.loopingEventTick))
		cancel(%this.loopingEventTick);
		
	%this.loopingEventTickClient = %client;
	
	if(%this.tickPausedTime && %this.tickPausedTime < %this.loopingEventTickTime)
	{
		%this.loopingEventTick = %this.schedule(%this.tickPausedTime, brickLoopingEventLoop, %client);
		return;
	}
		
	%this.loopingEventTick = %this.schedule(%this.loopingEventTickTime, brickLoopingEventLoop, %client);
}

function fxDtsBrick::stopTick(%this)
{	
	if(isEventPending(%this.loopingEventTick))
	{
		cancel(%this.loopingEventTick);
	}
		
	%this.tickPausedTime = "";
}

function fxDtsBrick::pauseTick(%this)
{
	if(isEventPending(%this.loopingEventTick))
	{
		%this.tickPausedTime = %this.loopingEventTickTime - mFloatLength(($sim::time - %this.lastLoopingEventTick)*1000, 0);
		
		if(!%this.tickPausedTime > 0)
			%this.tickPausedTime = "";
			
		cancel(%this.loopingEventTick);
	}
}